#!/bin/awk -f
#
# usage: script [-v page=num] file
#

func rnd(x,n){
  return int( 10^n * x + 0.5 ) / 10^n;
}

func mm(x, w,   A4V, BP2MM){
  A4V = 297;
  BP2MM = 25.4 / 72;

  if (w == 0) return x * BP2MM;
  else {
    if (w == 1) return ( A4V - x * BP2MM );
  }

  return 0;
}

BEGIN{
  
  if ( ! page ) page = 1;

  curpage = 0;
  PRTLINE = 1;
  HLINE = 0;
  VLINE = 0;

  while((getline < ARGV[1]) > 0 ){
    if ( $0 ~ /^%%Page: / ) curpage ++;
    if ( curpage < page ) continue;
    if ( curpage > page ) break;
	
    if ( $0 ~ /sc$/ ){
      if ( $1 == 1 && $2 == 1 && $3 == 1) PRTLINE = 0;
      else PRTLINE = 1;
    }

    if ( PRTLINE == 1 && $0 ~ /rf$/ ) {
if ( $3 >= 0 ) {
  W0 = $3;
}else{
  W0 = -$3;
}
if ( $4 >= 0 ) {
  H0 = $4;
}else{
  H0 = -$4;
}
      if ( W0 >= H0 ) {
	H["%H"HLINE] = rnd($1,2)" "rnd($2,2)" "rnd($3,2)" "rnd($4,2)" %H"HLINE;
	HLINE ++;
      }else{
	V["%V"VLINE] = rnd($1,2)" "rnd($2,2)" "rnd($3,2)" "rnd($4,2)" %V"VLINE;
	VLINE ++;
      }
    }
  }
  close(ARGV[1]);


  BOXNUMBER = 0;

  for (i in V) {
    split(V[i],VV);
    BOTNUM = "";
    TOPNUM = "";

    for (j in H){
      split(H[j],HH);

      if (HH[4] != VV[4]) continue;

      if (HH[1] == VV[1]){
	if (HH[2] >= VV[2] - VV[4] && HH[2] <= VV[2]) BOTNUM = $5;
	if (HH[2] >= VV[2] - VV[4] + VV[3] && HH[2] <= VV[2] + VV[3]) 
	  TOPNUM = $5;
      }else{
	if (HH[1] > VV[1] && HH[1] <= VV[1] + VV[4]){
	  if (HH[2] == VV[2]) BOTNUM = HH[5];
	  if (rnd(HH[2]+VV[4],2) == rnd(VV[2]+VV[3],2)) TOPNUM = HH[5];
	}
      }
    }

    if ( BOTNUM != "" && TOPNUM != "" ) {
      LABS[BOXNUMBER] = VV[5]" "BOTNUM" "TOPNUM;
      BOXNUMBER ++;
    }
  }

  for (i in LABS){
    split(LABS[i],LL);

    split(V[LL[1]],VL);
    split(H[LL[2]],HB);
    split(H[LL[3]],HT);

    for (j in V){
      split(V[j],VV);
      if (VV[1] >= HB[1] + HB[3] - HB[4] && VV[1] <= HB[1] + HB[3] &&
	  VV[1] >= HT[1] + HT[3] - HT[4] && VV[1] <= HT[1] + HT[3]){
	if ((VV[1] != HB[1] + HB[3] -HB[4] && VV[2] <= HB[2]) ||
	    (VV[1] == HB[1] + HB[3] -HB[4] && VV[2] <= HB[2] + HB[4])){
	  if ((VV[1] != HT[1] + HT[3] - HT[4] && 
	       VV[2] + VV[3] >= HT[2] + HT[4]) ||
	      (VV[1] == HT[1] + HT[3] - HT[4] && VV[2] + VV[3] >= HT[2])){
	    LABS[i] = LABS[i]" "VV[5];
	  }
	}
      }
    }
  }

  for (i in LABS){
    split(LABS[i],LL);

    split(V[LL[1]],VL);
    split(H[LL[2]],HB);
    split(H[LL[3]],HT);
    split(V[LL[4]],VR);

    printf "%-5s:(%6.2f,%6.2f)-(%6.2f,%6.2f) ",
      "Box",mm(VL[1],0), mm(HT[2] + HT[4],1), mm(VR[1],0), mm(HB[2] + HB[4],1);
    printf "%%NW(out)-SE(in),    thickness=%4.2fbp\n",VL[4];

    if (VR[2] < HB[2]){ 
      printf "%-5s:(%6.2f,%6.2f)->%6.2f         ",
	"Vrule",mm(VR[1],0), mm(HB[2],1), mm(HB[2] - VR[2],1);
      printf "%%NW(corner)->SW(y), thickness=%4.2fbp\n",VR[4];
    }

    if (VR[2] + VR[3] > HT[2] + HT[4]){
      printf "%-5s:(%6.2f,%6.2f)->%6.2f         ",
	"Vrule",mm(VR[1],0), mm(VR[2] + VR[3],1), mm(HT[2] + HT[4],1);
      printf "%%NW(corner)->SW(y), thickness=%4.2fbp\n",VR[4];
    }
  }
  PRINTLINE = 1;
}

(/^%%Page:/ && $2 == page),/^%%EndPage/{
  DETECT = 0;
  if ( $0 ~ /sc$/ ){
    if ($1 == 1 && $2 == 1 && $3 == 1) PRINTLINE = 0;
    else{
      PRINTLINE = 1;
      if ($1 == 0 && $2 == 0 && $3 == 0) print "%Black";
      else printf "%%Color: %s %s %s\n", $1, $2, $3;
    }
  }
  if ( PRINTLINE != 0 && $0 ~ /rf$/) {
    for (i in LABS){
      split(LABS[i],LL);
      if ( $3 >= $4 ){
	split(H[LL[2]],HB);
	split(H[LL[3]],HT);
	if ((HB[1] == rnd($1,2) && HB[2] == rnd($2,2) && HB[3] == rnd($3,2) &&
	     HB[4] == rnd($4,2)) ||
	    (HT[1] == rnd($1,2) && HT[2] == rnd($2,2) && HT[3] == rnd($3,2) &&
	     HT[4] == rnd($4,2)) ) {
	  DETECT = 1;
	  break;
	}
      }else{
	split(V[LL[1]],VL);
	split(V[LL[4]],VR);
	if ((VL[1] == rnd($1,2) && VL[2] == rnd($2,2) && VL[3] == rnd($4,2) &&
	     VL[4] == rnd($3,2)) ||
	    (VR[1] == rnd($1,2) && VR[2] == rnd($2,2) && VR[3] == rnd($4,2) &&
	     VR[4] == rnd($3,2)) ) {
	  DETECT = 1;
	  break;
	}
      }
    }

if ( $3 >= 0 ) {
  X0 = $1;
  W0 = $3;
}else{
  X0 = $1 + $3;
  W0 = -$3;
}
X1 = X0 + W0;
if ( $4 >= 0 ) {
  Y0 = $2 + $4;
  H0 = $4;
}else{
  Y0 = $2;
  H0 = -$4;
}
Y1 = Y0 - H0;

    if ( DETECT != 1 ) {
      if (W0 >= H0) {
	printf "%-5s:(%6.2f,%6.2f)->%6.2f ",
	  "Hrule", mm(rnd(X0,2),0), mm(rnd(Y0,2),1), mm(rnd(X1,2),0);
	printf "%%NW(corner)->NE(x), thickness=%4.2fbp len=%6.2f\n",rnd(H0,2),mm(rnd(W0,2),0);
      }else{
	printf "%-5s:(%6.2f,%6.2f)->%6.2f ",
	  "Vrule", mm(rnd(X0,2),0), mm(rnd(Y0,2),1), mm(rnd(Y1,2),1);
	printf "%%NW(corner)->SW(y), thickness=%4.2fbp len=%6.2f\n",rnd(W0,2),mm(rnd(H0,2),0);
      }
    }
  }
}
